<template>
  <div class="heroslider" :class="{ down: direction !== 'up' }">
    <ModuleHeroSliderItem
      v-for="(item, i) in items"
      :key="`slide-${i}`"
      :class="{
        current: current === i,
        out: last === i,
      }"
      class="heroslider__slide"
      :item="item"
      :style="{ transitionDuration: speed + 'ms', backgroundColor: item.color }"
    />
  </div>
</template>

<script>
export default {
  props: {
    items: {
      type: Array,
      default: null,
    },
    delay: {
      type: Number,
      default: 4000,
    },
    speed: {
      type: Number,
      default: 800,
    },
    autoplay: {
      type: Boolean,
      default: false,
    },
    loop: {
      type: Boolean,
      default: true,
    },
    direction: {
      type: String,
      default: 'up',
    },
  },
  data() {
    return {
      current: 0,
      last: null,
      timer: null,
      timeout: null,
      stopped: false,
    }
  },
  watch: {
    items(newValue, oldValue) {
      this.current = 0
    },
  },

  mounted() {
    if (this.autoplay) this.start()
  },
  methods: {
    start() {
      if (!this.autoplay || this.items.length <= 1) return

      this.stopped = false
      this.current = 0
      this.timer = setInterval(this.change, this.delay)
    },

    stop() {
      this.resetTimer()
      this.$emit('stopped')

      if (this.timeout) {
        clearTimeout(this.timeout)
        this.timeout = null
      }
    },

    resume() {
      if (!this.autoplay || this.items.length <= 1) return

      this.stopped = false
      this.resumeTimer()
      this.$emit('resumed')
    },

    resetTimer() {
      clearInterval(this.timer)
    },

    resumeTimer() {
      if (!this.autoplay || this.items.length <= 1) return
      this.timer = setInterval(this.change, this.delay)
    },

    change() {
      if (!this.stopped) {
        this.$emit('change')
        const t = this
        t.last = t.current
        t.current++

        if (t.current >= t.items.length && !this.loop) this.stop()
        if (t.current >= t.items.length) t.current = 0

        if (this.timeout) {
          clearTimeout(this.timeout)
          this.timeout = null
        }

        this.timeout = setTimeout(() => {
          t.last = null
          t.$emit('afterChange')
        }, t.speed + 300)
      }
    },

    next() {
      this.change()
    },

    beforeDestroy() {
      clearInterval(this.timer)
    },
  },
}
</script>

<style lang="scss" scoped>
$duration: 200ms;
// $easing: cubic-bezier(0.87, 0, 0.13, 1); // in out expo
// $easing: cubic-bezier(0.85, 0, 0.15, 1); // in out circ
$easing: cubic-bezier(0.83, 0, 0.17, 1); // in out quint

.heroslider {
  @apply w-full  overflow-hidden relative;

  height: 100%;

  @screen lg {
    @apply h-full;
  }

  &__slide {
    @apply absolute;

    top: 100%;
    left: intial;

    z-index: -1;
    transition-duration: 0;
    transition: none;
    will-change: right, top;

    right: 0px;
    @screen lg {
      right: 150px;
    }

    &.current {
      top: 0;
      right: 0;
      transition-property: top, right;

      transition-timing-function: $easing;
      transition-duration: $duration;
      z-index: 0;
    }

    &.out {
      top: -100%;

      right: -80px;
      @screen lg {
        right: -150px;
      }

      transition-property: top, right;
      transition-timing-function: $easing;
      transition-duration: $duration;
      z-index: 1;
    }
  }
}
.heroslider.down {
  .heroslider__slide {
    top: -100%;
    right: initial;

    left: 0px;

    @screen lg {
      left: 150px;
    }
    will-change: left, top;
    &.current {
      transition-property: top, left;
      top: 0;
      left: 0px;
    }

    &.out {
      transition-property: top, left;
      top: 100%;
      left: -80px;

      @screen lg {
        left: -150px;
      }
    }
  }
}
</style>
